module.exports = {
    env: {
        node: true,  // Indicates that the code runs in a Node.js environment
        es2021: true
    },
    root: true,
    parser: "@typescript-eslint/parser",
    parserOptions: {
        ecmaVersion: 2020,
        sourceType: "module",
        ecmaFeatures: {
            jsx: true,
        },
        // project: "./tsconfig.json",
    },
    settings: {
        react: {
            version: "detect",
        },
    },
    extends: [
        "eslint:recommended",
        "plugin:@typescript-eslint/recommended",
        // Add more specific rules if needed
    ],
    rules: {
        // Add custom rules or override existing ones here
    },
    overrides: [
        {
            files: ["*.js"],
            rules: {
                "@typescript-eslint/no-var-requires": "off",
                // Additional JavaScript specific rules
            },
        },
    ],
};
